﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.Xml;
using System.Xml.Serialization;
using System.IO;
using System.Runtime.Serialization.Json;
using System.Runtime.Serialization;





public class Utilities{


    //==============================================================================================
    // OBJECT SERIALIZATION STUFF
    //==============================================================================================
    static private String UTF8ByteArrayToString(Byte[] characters)
    {
        UTF8Encoding encoding = new UTF8Encoding();
        String constructedString = encoding.GetString(characters,0,characters.Length );
        return (constructedString);
    }
    static private Byte[] StringToUTF8ByteArray(String pXmlString)
    {
        UTF8Encoding encoding = new UTF8Encoding();
        Byte[] byteArray = encoding.GetBytes(pXmlString);
        return byteArray;
    }

    static public string Serialize(object obj)
    {
        if (obj == null) throw new ArgumentNullException("obj");
        DataContractSerializer dcs = new DataContractSerializer(obj.GetType());
        MemoryStream ms = new MemoryStream();
        dcs.WriteObject(ms, obj);
        return Encoding.UTF8.GetString(ms.GetBuffer(), 0, (int)ms.Position);
    }

    static public object Deserialize(Type type, string serialized)
    {
        if (type == null) throw new ArgumentNullException("type");
        if (serialized == null) throw new ArgumentNullException("serialized");
        DataContractSerializer dcs = new DataContractSerializer(type);
        MemoryStream ms = new MemoryStream(Encoding.UTF8.GetBytes(serialized));
        return dcs.ReadObject(ms);
    }





    






    //==============================================================================================
    // UTILITIES FOR WORKING WITH TELERIK TREEVIEWS
    //==============================================================================================
    


}